﻿package FMPhysics{
  import flash.display.Sprite;
  
  public class Draw{
    
    public static function drawCurve(pt: Array, sp: Sprite):void{
      if(pt.length >= 3){
        sp.graphics.moveTo(pt[0].x, pt[0].y);
        for(var i:Number = 1; i <= pt.length-3; ++i){
          sp.graphics.curveTo(pt[i].x, pt[i].y, (pt[i].x+pt[i+1].x)/2, (pt[i].y+pt[i+1].y)/2);      
        }
        sp.graphics.curveTo(pt[pt.length-2].x, pt[pt.length-2].y, pt[pt.length-1].x, pt[pt.length-1].y);
      }  
    }
    
    public static function drawRing(pt: Array, sp: Sprite, col: uint):void{
      if(pt.length >= 3){
        sp.graphics.moveTo((pt[pt.length-1].x+pt[0].x)/2, (pt[pt.length-1].y+pt[0].y)/2);
        sp.graphics.beginFill(col);
        for(var i:Number = 0; i < pt.length; ++i){
          sp.graphics.curveTo(pt[i].x, pt[i].y, (pt[i].x+pt[(i+1) % pt.length].x)/2, (pt[i].y+pt[(i+1) % pt.length].y)/2);
        }
        sp.graphics.endFill();
      }  
    }
    
    public static function drawContinuousCurve(pt: Array, sp: Sprite):void{
      if(pt.length >= 3){
        sp.graphics.lineTo(pt[0].x, pt[0].y);
        for(var i:Number = 1; i <= pt.length-3; ++i){
          sp.graphics.curveTo(pt[i].x, pt[i].y, (pt[i].x+pt[i+1].x)/2, (pt[i].y+pt[i+1].y)/2);      
        }
        sp.graphics.curveTo(pt[pt.length-2].x, pt[pt.length-2].y, pt[pt.length-1].x, pt[pt.length-1].y);
      }  
    }
  }
}
