﻿package{
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.utils.Timer;
	import flash.events.Event;
	import flash.events.TimerEvent;
	import flash.events.KeyboardEvent;
	import flash.filters.BlurFilter;
	import flash.filters.BitmapFilterQuality;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.net.URLLoaderDataFormat;
	import flash.text.TextField;
	import flash.text.TextFormat;
	import flash.text.TextFormatAlign;
	
	import FMPhysics.PhysicalPoint;

	public class Metaball extends MovieClip{
		var dotsSp:Sprite = new Sprite();
		var bokashiBmp:Bitmap;
		var metaBallBmp:Bitmap;
		var bokashiBmpData:BitmapData;
		var metaBallBmpData:BitmapData;

		var baseSp:Sprite = new Sprite();
		var maskSp:Sprite = new Sprite();

		var titleSp:Sprite = new Sprite();
		var layerView:Sprite = new Sprite();

		var monitorWidth:Number = 300;
		var monitorHeight:Number = 400;
		
		const DOTS_MODE:Number = 0;
		const BOKASHI_MODE:Number = 1;
		const METABALL_MODE:Number = 2;
		var curViewMode:Number = METABALL_MODE;
		
		var metaBlur:BlurFilter = new BlurFilter(50, 50, BitmapFilterQuality.HIGH); 
				
		var obj:Array = new Array();
		var pt:Array = new Array();
		var loc:Array = new Array();
		var titleTf:Array = new Array();
		
		var preNum:Number = 0;
		var curNum:Number = 0;
		var changedTime:uint = new Date().getTime();
		
		var curArrayNum:Number = 0;
		var numArray:Array = new Array();
		
		function Metaball(){
			graphics.lineStyle(0, 0, 0);
			graphics.beginFill(0xDDDDCC);
			graphics.drawRect(0, 0, stage.stageWidth, stage.stageHeight);
			graphics.endFill();
			
			dotsSp.graphics.lineStyle(0, 0, 0);
			dotsSp.graphics.beginFill(0xFFFFFF);
			dotsSp.graphics.drawRect(0, 0, monitorWidth, monitorHeight);
			dotsSp.graphics.endFill();
			dotsSp.alpha = 0;
			dotsSp.x = stage.stageWidth/2 - monitorWidth/2;
			dotsSp.y = stage.stageHeight/2 - monitorHeight/2 - 30;
			
			bokashiBmpData = new BitmapData(monitorWidth, monitorHeight, false, 0xFFFFFF);
			bokashiBmp = new Bitmap(bokashiBmpData);
			bokashiBmp.alpha = 0;
			bokashiBmp.x = stage.stageWidth/2 - monitorWidth/2;
			bokashiBmp.y = stage.stageHeight/2 - monitorHeight/2 - 30;
			
			metaBallBmpData = new BitmapData(monitorWidth, monitorHeight, false, 0xFFFFFF);
			metaBallBmp = new Bitmap(metaBallBmpData);
			metaBallBmp.filters = [new BlurFilter(10, 10, BitmapFilterQuality.HIGH)];
			metaBallBmp.x = stage.stageWidth/2 - monitorWidth/2;
			metaBallBmp.y = stage.stageHeight/2 - monitorHeight/2 - 30;

			layerView.x = stage.stageWidth/2;
			layerView.y = stage.stageHeight-55;
			
			var haba:Number = 150;
			titleSp.x = stage.stageWidth/2 - haba/2;
			titleSp.y = stage.stageHeight/2 + monitorHeight/2 - 10;
			titleSp.graphics.clear();
			titleSp.graphics.lineStyle(1, 0x999933);
			titleSp.graphics.beginFill(0xFFFFFF);
			titleSp.graphics.drawRect(0, 0, haba, 20);
			titleSp.graphics.endFill();

			maskSp.graphics.clear();
			maskSp.graphics.lineStyle(0, 0, 0);
			maskSp.graphics.beginFill(0xFF0000);
			maskSp.graphics.drawRect(stage.stageWidth/2 - monitorWidth/2, stage.stageHeight/2 - monitorHeight/2 - 30, monitorWidth, monitorHeight);
			maskSp.graphics.endFill();
			baseSp.mask = maskSp;
			
			baseSp.addChild(metaBallBmp);
			baseSp.addChild(bokashiBmp);
			baseSp.addChild(dotsSp);
			addChild(maskSp);
			addChild(baseSp);
			addChild(layerView);
			addChild(titleSp);
			
			stage.addEventListener(KeyboardEvent.KEY_DOWN, onKDown);

			var xmlLoader:URLLoader = new URLLoader();
			xmlLoader.dataFormat = URLLoaderDataFormat.TEXT;
			xmlLoader.addEventListener(Event.COMPLETE, onXMLLoaded);
			xmlLoader.load(new URLRequest("keijo.xml"));
		}
		
		function onXMLLoaded(event:Event):void{
			
			try{
				var theXml: XML = new XML(event.target.data);
				
				for(var i:Number = 0; i < Number(theXml.@pointNum); ++i){
					pt.push(new PhysicalPoint(monitorWidth/2, monitorHeight/2));
					
					obj.push(new Sprite());
					obj[obj.length-1].graphics.lineStyle(0, 0, 0);
					obj[obj.length-1].graphics.beginFill(0x111111);
					obj[obj.length-1].graphics.drawCircle(0, 0, 30);
					obj[obj.length-1].graphics.endFill();
					
					dotsSp.addChild(obj[obj.length-1]);
				}

				var tfm:TextFormat = new TextFormat("ヒラギノ明朝 ProN W6", 14);
				tfm.align = TextFormatAlign.CENTER;
				
				for each(var keijo:XML in theXml.keijo){
					loc.push(new Array());
					for each(var kpt:XML in keijo.pt){
						loc[loc.length-1].push(new Point(Number(kpt.@x), Number(kpt.@y)));
					}
					titleTf.push(new TextField());
					titleTf[titleTf.length-1].text = "「"+keijo.@name+"」";
					titleTf[titleTf.length-1].embedFonts = true;
					titleTf[titleTf.length-1].setTextFormat(tfm);
					titleTf[titleTf.length-1].x = titleSp.x;
					titleTf[titleTf.length-1].y = titleSp.y;
					titleTf[titleTf.length-1].width = titleSp.width;
					titleTf[titleTf.length-1].height = titleSp.height;
					titleTf[titleTf.length-1].alpha = 0;
					addChild(titleTf[titleTf.length-1]);
				}

				shuffle();
				
				changePic(null);
				
				var changePicTimer:Timer = new Timer(20000);
				changePicTimer.addEventListener(TimerEvent.TIMER, changePic);
				changePicTimer.start();

				var timer:Timer = new Timer(33);
				timer.addEventListener(TimerEvent.TIMER, loop);
				timer.start();
			}catch(err:TypeError){
				trace(err);
			}
		}

		function changePic(event:TimerEvent):void{
			preNum = curNum;
			curNum = numArray[curArrayNum++];
			changedTime = new Date().getTime();
			if(curArrayNum == loc.length){
				shuffle();
				curArrayNum = 0;
			}
		}
		
		function shuffle(){
			numArray = new Array();
			for(var i:Number = 0; i < loc.length; ++i){
				numArray.push(i);
			}
			for(var j:Number = 0; j < 30; ++j){
				var a0:Number = Math.min(int(Math.random()*loc.length), loc.length-1);
				var a1:Number = Math.min(int(Math.random()*loc.length), loc.length-1);
				var temp:Number = numArray[a0];
				numArray[a0] = numArray[a1];
				numArray[a1] = temp;
			}
		}
		
		function loop(event:TimerEvent):void{
			
			switch(curViewMode){
				case DOTS_MODE:
					dotsSp.filters = null;
					dotsSp.alpha = Math.min(dotsSp.alpha+0.1, 1);
					bokashiBmp.alpha = Math.max(bokashiBmp.alpha-0.1, 0);
					metaBallBmp.alpha = Math.max(metaBallBmp.alpha-0.1, 0);
					break;
				case BOKASHI_MODE:
					dotsSp.filters = [metaBlur];
					dotsSp.alpha = Math.min(dotsSp.alpha+0.1, 1);
					bokashiBmp.alpha = Math.max(bokashiBmp.alpha-0.1, 0);
					metaBallBmp.alpha = Math.min(metaBallBmp.alpha+0.1, 1);
					break;
				case METABALL_MODE:
					dotsSp.filters = [metaBlur];
					dotsSp.alpha = Math.max(dotsSp.alpha-0.1, 0);
					bokashiBmp.alpha = Math.max(bokashiBmp.alpha-0.1, 0);
					metaBallBmp.alpha = Math.min(metaBallBmp.alpha+0.1, 1);
					break;
			}
			
			layerDraw();
			
			var intervalTime:Number = 700;
			var ima:uint = new Date().getTime() - changedTime;
	
			for(var j:Number = 0; j < pt.length; ++j){
				if(ima < j*intervalTime){
					pt[j].setKasokudo((loc[preNum][j].x - pt[j].x)*8, (loc[preNum][j].y - pt[j].y)*8);
				}else{
					pt[j].setKasokudo((loc[curNum][j].x - pt[j].x)*8, (loc[curNum][j].y - pt[j].y)*8);
				}
				
				obj[j].x = pt[j].x;
				obj[j].y = pt[j].y;
			}
		
			bokashiBmpData.draw(dotsSp);
			
			metaBallBmpData.fillRect(new Rectangle(0, 0, bokashiBmpData.width, bokashiBmpData.height), 0xFFFFFF);
			var sourceRect:Rectangle = new Rectangle(0, 0, metaBallBmpData.width, metaBallBmpData.height);
			var destPt:Point = new Point(0, 0);
			var threshold:uint =  0x00999999; 
			var color:uint = 0x0000FF00;
			var maskColor:uint = 0x00FFFFFF;
			metaBallBmpData.threshold(bokashiBmpData, sourceRect, destPt, "<", threshold, color, maskColor, false);

			for(var i:Number = 0; i < titleTf.length; ++i){
				if(i == curNum && ima > pt.length*intervalTime){
					titleTf[i].alpha += (1 - titleTf[i].alpha)/10;
				}else{
					titleTf[i].alpha += (0 - titleTf[i].alpha)/10;
				}
			}
		}
		
		function onKDown(event:KeyboardEvent):void{
			if(event.keyCode == 32){
				curViewMode = ++curViewMode % 3;
			}
		}
		
		function layerDraw():void{
			layerView.graphics.clear();
			
			for(var i:Number = 0; i < 3; ++i){
				var w:Number = 20;
				var h1:Number = 10;
				var h2:Number = 9;
				var kankaku:Number = 5;
				layerView.graphics.moveTo(-w, 0-kankaku*i);
				if(curViewMode == i){
					layerView.graphics.lineStyle(1, 0x000000, 0.7);
					layerView.graphics.beginFill(0xAA0000, 0.7)
				}else{
					layerView.graphics.lineStyle(1, 0x000000, 0.3);
					layerView.graphics.beginFill(0x000000, 0.3)
				}
				layerView.graphics.lineTo(0, -h2-kankaku*i);
				layerView.graphics.lineTo(w, 0-kankaku*i);
				layerView.graphics.lineTo(0, h1-kankaku*i);
				layerView.graphics.lineTo(-w, 0-kankaku*i);
				layerView.graphics.endFill();
			}
			
		}
	}
}
