﻿package{
	
	import flash.display.MovieClip;
	import flash.display.Sprite;
	import flash.utils.Timer;
	import flash.events.TimerEvent;
	import flash.geom.Point;
	import flash.filters.BitmapFilterQuality; 
	import flash.filters.BitmapFilterType;
	import flash.filters.GradientGlowFilter;
	import flash.media.Microphone;
	import flash.events.StatusEvent;
	import flash.system.Security;
	import flash.system.SecurityPanel;
	
	import FMPhysics.Point3D;
	import FMPhysics.PhysicalPoint;
	
	public class Tenkai extends MovieClip{
		var base:Sprite = new Sprite();
		var motoPt:Array = new Array();
		
		var mic:Microphone;
		var akeru:PhysicalPoint = new PhysicalPoint();
		
		var startTime:uint = new Date().getTime();
		
		function Tenkai(){
			mic = Microphone.getMicrophone();
			Security.showSettings(SecurityPanel.PRIVACY);
            if (mic != null) {
	            mic.setLoopBack(true);
                mic.setUseEchoSuppression(true);
                mic.addEventListener(StatusEvent.STATUS, statusHandler);
            }
			
			var gradientGlow: GradientGlowFilter = new GradientGlowFilter();
			gradientGlow.distance = 0;
			gradientGlow.angle = 0;
			gradientGlow.colors = [0x9999FF, 0x9999FF];
			gradientGlow.alphas = [0, 1];
			gradientGlow.ratios = [0, 255];
			gradientGlow.blurX = 20;
			gradientGlow.blurY = 20;
			gradientGlow.strength = 3;
			gradientGlow.quality = BitmapFilterQuality.HIGH;
			gradientGlow.type = BitmapFilterType.OUTER;

			base.filters = [gradientGlow];
			
			base.x = stage.stageWidth/2;
			base.y = stage.stageHeight/2;
			addChild(base);
		
			var size:Number = 100;
			motoPt = [	[new Point3D(-size, size, -size),new Point3D(-size, size, size),new Point3D(size, size, size),new Point3D(size, size, -size)], 
					[new Point3D(-size, size, -size),new Point3D(-size, -size, -size),new Point3D(size, -size, -size),new Point3D(size, size, -size)], 
					[new Point3D(-size, size, -size),new Point3D(-size, -size, -size),new Point3D(-size, -size, size),new Point3D(-size, size, size)], 
					[new Point3D(-size, size, size),new Point3D(-size, -size, size),new Point3D(size, -size, size),new Point3D(size, size, size)], 
					[new Point3D(size, size, size),new Point3D(size, -size, size),new Point3D(size, -size, -size),new Point3D(size, size, -size)], 
					[new Point3D(-size, -size, -size),new Point3D(-size, -size, size),new Point3D(size, -size, size),new Point3D(size, -size, -size)]
				];
		
			var timer:Timer = new Timer(33);
			timer.addEventListener(TimerEvent.TIMER, loop);
			timer.start();
		}
		
		private function statusHandler(ev:StatusEvent):void {
			if(ev.code == "Microphone.Muted") trace("マイクが使えません。");
		}
		
		function loop(event:TimerEvent):void{
			
			var par:Number = mic.activityLevel/100*Math.PI/2;
			
			if(par > akeru.angle){
				akeru.setKakuKasokudo((par - akeru.angle)*300);
			}else{
				akeru.setKakuKasokudo((par - akeru.angle)*10);
			}
						
			var pt:Array = duplicate();
			
			pt[1][1].rotateX(akeru.angle, pt[1][0].x, pt[1][0].y, pt[1][0].z);
			pt[1][2].rotateX(akeru.angle, pt[1][0].x, pt[1][0].y, pt[1][0].z);

			pt[2][1].rotateZ(-akeru.angle, pt[2][0].x, pt[2][0].y, pt[2][0].z);
			pt[2][2].rotateZ(-akeru.angle, pt[2][0].x, pt[2][0].y, pt[2][0].z);

			pt[3][1].rotateX(-akeru.angle, pt[3][0].x, pt[3][0].y, pt[3][0].z);
			pt[3][2].rotateX(-akeru.angle, pt[3][0].x, pt[3][0].y, pt[3][0].z);

			pt[4][1].rotateZ(akeru.angle, pt[4][0].x, pt[4][0].y, pt[4][0].z);
			pt[4][2].rotateZ(akeru.angle, pt[4][0].x, pt[4][0].y, pt[4][0].z);
			
			
			pt[5][0].shift(0, pt[1][1].y - motoPt[5][0].y, pt[1][1].z - motoPt[5][0].z);
			pt[5][1].shift(0, pt[1][1].y - motoPt[5][0].y, pt[1][1].z - motoPt[5][0].z);
			pt[5][2].shift(0, pt[1][1].y - motoPt[5][0].y, pt[1][1].z - motoPt[5][0].z);
			pt[5][3].shift(0, pt[1][1].y - motoPt[5][0].y, pt[1][1].z - motoPt[5][0].z);

			pt[5][1].rotateX(akeru.angle*2, pt[5][0].x, pt[5][0].y, pt[5][0].z);
			pt[5][2].rotateX(akeru.angle*2, pt[5][0].x, pt[5][0].y, pt[5][0].z);

			var passedTime:Number = (new Date().getTime() - startTime)/1000*Math.PI*2*0.02;
			
			rotateX(pt, passedTime, 0, 0, 0);
			rotateY(pt, passedTime, 0, 0, 0);
			rotateZ(pt, passedTime, 0, 0, 0);
						
			shift(pt, 0, 0, 600);
			
			var pt2:Array = toei(pt, 100, 5);
			
			byoga(pt2, base);
		}
		
		function duplicate():Array{
			var ret:Array = new Array();
			for(var i:Number = 0; i < motoPt.length; ++i){
				ret.push(new Array());
				for(var j:Number = 0; j < motoPt[i].length; ++j){
					ret[ret.length-1].push(new Point3D(motoPt[i][j].x, motoPt[i][j].y, motoPt[i][j].z));
				}
			}
			return ret;
		}
				
		function rotateX(pt:Array, val:Number, cx:Number, cy:Number, cz:Number){
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point3D){
							pt[i][j].rotateX(val, cx, cy, cz);
						}
					}
				}
			}
		}
		
		function rotateY(pt:Array, val:Number, cx:Number, cy:Number, cz:Number){
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point3D){
							pt[i][j].rotateY(val, cx, cy, cz);
						}
					}
				}
			}
		}
		
		function rotateZ(pt:Array, val:Number, cx:Number, cy:Number, cz:Number){
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point3D){
							pt[i][j].rotateZ(val, cx, cy, cz);
						}
					}
				}
			}
		}
		
		function shift(pt:Array, dx:Number, dy:Number, dz:Number){
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point3D){
							pt[i][j].shift(dx, dy, dz);
						}
					}
				}
			}
		}

		function toei(pt:Array, sc:Number, bai:Number = 1){
			var ret:Array = new Array();
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					ret.push(new Array());
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point3D){
							var retX:Number = pt[i][j].x * sc / pt[i][j].z;
							var retY:Number = pt[i][j].y * sc / pt[i][j].z;
							ret[ret.length-1].push(new Point(retX*bai, retY*bai));
						}
					}
				}
			}
			return ret;
		}
		
		function byoga(pt:Array, sp:Sprite){
			sp.graphics.clear();
			for(var i:Number = 0; i < pt.length; ++i){
				if(pt[i] is Array){
					for(var j:Number = 0; j < pt[i].length; ++j){
						if(pt[i][j] is Point){
							if(j == 0){
								sp.graphics.lineStyle(5, 0xFFFFFF, Math.random()*0.6+0.4);
								sp.graphics.moveTo(pt[i][j].x, pt[i][j].y);
							}else{
								sp.graphics.lineTo(pt[i][j].x, pt[i][j].y);
							}
							if(j == 3){
								sp.graphics.lineTo(pt[i][0].x, pt[i][0].y);
							}
						}
					}
				}
			}
		}
	}
}
