﻿package FMPhysics{
  import flash.display.Sprite;
  import flash.text.TextField;
  import flash.text.TextFormat;
 
  public class FMIndicator extends Sprite{
	var indicator:Sprite = new Sprite();
	var indicatorBase:Sprite = new Sprite();
	public var size:Number;
	public var minValue:Number;
	public var maxValue:Number;
	private var value:Number;
	var tabList:Array;
	var valueList:Array;
	var takasa:Number = 2;
		
	function FMIndicator(minV:Number = 0, maxV:Number = 100, v:Number = 0, s:Number = 300, tl:Array = null, vl:Array = null){
		minValue = minV;
		maxValue = maxV;
		value = v;
		size = s;
		tabList = tl;
		valueList = vl;
		
		addChild(indicatorBase);
		indicator.graphics.lineStyle(0, 0, 0);
		indicator.graphics.beginFill(0xFF0000);
		indicator.graphics.drawRect(0, takasa, 1, 2);
		indicator.graphics.endFill();
		indicator.x = 0;
		indicator.y = 0;
		indicator.scaleX = 0;
		addChild(indicator);
		
		setList();
	}
    
	public function setList(tl:Array = null, vl:Array = null){
		if(tl != null && vl != null){
			tabList = tl;
			valueList = vl;
		}
		if(tabList != null && valueList != null){
			indicatorBase.graphics.clear();
			indicatorBase.graphics.lineStyle(1, 0x008800);
			var locX:Array = new Array();
			locX.push(0);
			for(var i:Number = 0; i < valueList.length; ++i){
				var xx:Number = (valueList[i]-minValue)/(maxValue-minValue)*size;
				indicatorBase.graphics.moveTo(xx, -takasa);
				indicatorBase.graphics.lineTo(xx, 0);
				locX.push(xx);
			}
			
			var kazu:Number = indicatorBase.numChildren;
			for(var j:Number = 0; j < kazu; ++j){
				indicatorBase.removeChild(indicatorBase.getChildAt(0));
			}
			for(var k:Number = 0; k < tabList.length; ++k){
				var tfm:TextFormat = new TextFormat("ＭＳ Ｐゴシック", 10, 0x00FF00);
				tfm.align = "center";
				var tf:TextField = new TextField();
				tf.defaultTextFormat = tfm;
				tf.text = tabList[k];
				tf.x = locX[k];
				tf.y = 4;
				tf.width = locX[k+1] - locX[k];
				indicatorBase.addChild(tf);
			}
			indicatorBase.graphics.moveTo(0, -takasa);
			indicatorBase.graphics.lineTo(0, 0);
			indicatorBase.graphics.lineTo(size, 0);
			indicatorBase.graphics.lineTo(size, -takasa);

		}
	}
	
	public function setValue(v:Number){
		value = v;
		indicator.scaleX = (value-minValue)/(maxValue-minValue)*size;
	}
  }
}
