﻿package FMPhysics{
	public class Point3D{
		
		public var x:Number = 0;
		public var y:Number = 0;
		public var z:Number = 0;
		
		function Point3D(xx:Number = 0, yy:Number = 0, zz:Number = 0){
			x = xx;
			y = yy;
			z = zz;
		}
		
		public function shift(valX:Number, valY:Number, valZ:Number){
			x += valX;
			y += valY;
			z += valZ;
		}
		
		public function rotateX(val:Number, cx:Number, cy:Number, cz:Number){
			var tempX1:Number = x - cx;
			var tempY1:Number = y - cy;
			var tempZ1:Number = z - cz;
			
			var tempX2:Number = tempX1;
			var tempY2:Number = tempY1*Math.cos(val) - tempZ1*Math.sin(val);
			var tempZ2:Number = tempY1*Math.sin(val) + tempZ1*Math.cos(val);

			x = tempX2 + cx;
			y = tempY2 + cy;
			z = tempZ2 + cz;
		}
		
		public function rotateY(val:Number, cx:Number, cy:Number, cz:Number){
			var tempX1:Number = x - cx;
			var tempY1:Number = y - cy;
			var tempZ1:Number = z - cz;
			
			var tempX2:Number = tempX1*Math.cos(val) - tempZ1*Math.sin(val);
			var tempY2:Number = tempY1;
			var tempZ2:Number = tempX1*Math.sin(val) + tempZ1*Math.cos(val);

			x = tempX2 + cx;
			y = tempY2 + cy;
			z = tempZ2 + cz;
		}
		
		public function rotateZ(val:Number, cx:Number, cy:Number, cz:Number){
			var tempX1:Number = x - cx;
			var tempY1:Number = y - cy;
			var tempZ1:Number = z - cz;
			
			var tempX2:Number = tempX1*Math.cos(val) - tempY1*Math.sin(val);
			var tempY2:Number = tempX1*Math.sin(val) + tempY1*Math.cos(val);
			var tempZ2:Number = tempZ1;

			x = tempX2 + cx;
			y = tempY2 + cy;
			z = tempZ2 + cz;
		}
		
		public function expand(val:Number, cx:Number, cy:Number, cz:Number){
			var tempX1:Number = x - cx;
			var tempY1:Number = y - cy;
			var tempZ1:Number = z - cz;
			
			var tempX2:Number = tempX1*val;
			var tempY2:Number = tempY1*val;
			var tempZ2:Number = tempZ1*val;

			x = tempX2 + cx;
			y = tempY2 + cy;
			z = tempZ2 + cz;
		}		
	}
}